# -*- coding: utf-8 -*-
import random

import irc3
from docopt import Dict as DocOptDict
from irc3.plugins.command import command
from irc3.utils import IrcString

from . import DatabasePlugin

RAINBOW = (5, 3, 7, 8, 9, 3, 10, 12, 2, 6, 13)
RAINBOW_LEN = len(RAINBOW)


@irc3.plugin
class Useless(DatabasePlugin):
    requires = ['irc3.plugins.command',
                'nxy.plugins.storage']

    @irc3.event(r'(?i)^:\S+ PRIVMSG (?P<target>\S+) :(?P<msg>huehuehue)$')
    def huehuehue(self, target: str, msg: str):
        """Returns a huehuehue when someone writes it."""
        self.bot.privmsg(target, msg)

    @irc3.event(r'(?i)^:\S+ PRIVMSG (?P<target>\S+) :reeeeee$')
    def reeeeee(self, target: str):
        """Returns a REEEE."""
        self.bot.privmsg(target, 'REEEEEEEEEEEEEEEEEEEEEEEEEEEE')

    @irc3.event(r'(?i)^:\S+ PRIVMSG (?P<target>\S+) :same$')
    def same(self, target: str):
        """Returns a plain same when a user writes same."""
        self.bot.privmsg(target, 'same')

    @irc3.event(r'(?i)^:\S+ PRIVMSG (?P<target>\S+) :\[(?P<msg>.*)\]$')
    def intensifies(self, target: str, msg: str):
        """String with brackets around will be returned with INTENSIFIES."""
        self.bot.privmsg(target, '\x02[{msg} INTENSIFIES]'.format(
            msg=msg.upper()))

    @command
    def kill(self, mask:IrcString,target:IrcString,args:DocOptDict):
        """Kills a user with a random message.

        %%kill [<nick>]
        """
        nick = args.get('<nick>') or mask.nick
        self.cur.execute('''
        select
          item
        from
          kills
        order by
          random()
        limit
          1
        ''')
        return self.cur.fetchone()['item'].format(nick=nick)

    @command
    def yiff(self, mask:IrcString,target:IrcString,args:DocOptDict):
        """Yiffs a user with a random message.

        %%yiff [<nick>]
        """
        nick = args.get('<nick>') or mask.nick
        self.cur.execute('''
        select
          item
        from
          yiffs
        order by
          random()
        limit
          1
        ''')
        return self.cur.fetchone()['item'].format(nick=nick)

    @command
    def storyofpomfface(self, mask: IrcString, target: IrcString,
                        args: DocOptDict):
        """Story of pomf face.

        %%storyofpomfface
        """
        for face in (':O C==3', ':OC==3', ':C==3', ':C=3', ':C3', ':3'):
            self.bot.privmsg(target, face)

    @command
    def choose(self, mask: IrcString, target: IrcString, args: DocOptDict):
        """Decides between items separated by comma.

        %%choose <items>...
        """
        choice = random.choice(' '.join(args['<items>']).split(','))
        return '{nick}, I\'d choose: {choice}'.format(nick=mask.nick,
                                                      choice=choice.strip())

    @command
    def jn(self, mask: IrcString, target: IrcString, args: DocOptDict):
        """Decides between yes and no (for a question).

        %%jn <question>
        %%jn
        """
        choice = random.choice(['3Ja', '4Nein'])
        return '{nick}: \x02\x03{choice}\x0F'.format(nick=mask.nick,
                                                     choice=choice)

    @command
    def kiss(self, mask: IrcString, target: IrcString, args: DocOptDict):
        """Kisses a user.

        %%kiss <nick>
        """
        return '(づ｡◕‿‿◕｡)\x034。。・゜゜・。。・゜❤\x0F {nick} \x034❤'.format(
            nick=args['<nick>'])

    @command
    def hug(self, mask: IrcString, target: IrcString, args: DocOptDict):
        """Hugs a user.

        %%hug <nick>
        """
        return '\x034♥♡❤♡♥\x03 {nick} \x034♥♡❤♡♥'.format(nick=args['<nick>'])

    @command
    def bier(self, mask: IrcString, target: IrcString, args: DocOptDict):
        """Gives nick a beer.

        %%bier [<nick>]
        """
        self.bot.action(target, 'schenkt ein kühles blondes an {nick} aus.'
                        .format(nick=args.get('<nick>') or mask.nick))

    @command
    def fucken(self, mask: IrcString, target: IrcString, args: DocOptDict):
        """Kills and fucks a nick.

        %%fucken [<nick>]
        """
        self.bot.action(target, 'fuckt {nick} und tötet {nick} anschließend.'
                        .format(nick=args.get('<nick>') or mask.nick))

    @command
    def anhero(self, mask: IrcString, target: IrcString, args: DocOptDict):
        """Kicks a nick.

        %%anhero
        """
        self.bot.privmsg(target, 'Sayonara bonzai-chan...')
        self.bot.kick(target, mask.nick)

    @command
    def sudoku(self, mask: IrcString, target: IrcString, args: DocOptDict):
        """Kicks a nick.

        %%sudoku
        """
        self.anhero(mask, target, args)

    @command
    def hack(self, mask: IrcString, target: IrcString, args: DocOptDict):
        """Hacks (a user).

        %%hack [<nick>]
        """
        nick = args.get('<nick>') or ''
        return 'hacking{nick}...'.format(nick=' %s' % nick if nick else '')

    @command
    def gay(self, mask: IrcString, target: IrcString, args: DocOptDict):
        """Make someone gay (alias to rainbow)

        %%gay <word>...
        """
        return self.rainbow(mask, target, args)

    @command
    def rainbow(self, mask: IrcString, target: IrcString, args: DocOptDict):
        """Colorize a word in rainbow colors.

        %%rainbow <word>...
        """
        last = 0
        word = []
        for char in ' '.join(args.get('<word>')):
            if char != ' ':
                char = self._rainbow(last, char)
                last += 1
            word.append(char)
        return ''.join(word)

    @command
    def wrainbow(self, mask: IrcString, target: IrcString, args: DocOptDict):
        """Colorize words in a sentence with rainbow colors.

        %%wrainbow <words>...
        """
        return ' '.join([self._rainbow(i, word) for i, word
                         in enumerate(args['<words>'])])

    @staticmethod
    def _rainbow(i, char):
        return '\x03{color}{char}'.format(color=RAINBOW[i % RAINBOW_LEN],
                                          char=char)
