# -*- coding: utf-8 -*-
import re

NICK_REGEX = re.compile(r'<?[~&@%+]?([a-zA-Z0-9_\-^`|\\\[\]{}]+)>?')


def parse_int(val: str, select: bool = True) -> tuple:
    try:
        val = int(val)
        if val is not 0:
            if val < 1:
                order, op = 'desc', '<='
                val *= -1
            else:
                order, op = 'asc', '>='
            if select:
                val -= 1
            return val, order, op
    except ValueError:
        pass
